# Скрипт фотохостинга "Akina"

- Название: Akina
- Назначение: фотохостинг
- Год выпуска: 2011-2020
- Лицензия: GNU GPL v2
- Язык Интерфейса: Руский
- Платформа/ОС: ALL (но желательно Unix-подобные)
- Сайт разработчиков: akina-photohost.org
- Написано на: PHP, JavaScript
- Размер: 270 KB

Скачать: https://github.com/vla7/akina/releases

## Описание
Бесплатный, простой и многофункциональный скрипт фотохостинга. Не требует много ресурсов, не использует базы данных. Поддерживает мультизагрузуку и уменьшение изображений.

## Системные требования
* PHP 5.0 и выше
* GD2 и выше
* cURL

## Пользовательские возможности
* загрузка изображений jpg, gif, png, bmp
* мультизагрузка с локального компьютера и с удаленного сервера (допустимо одновременно)
* единое поле для загрузки изображений с удаленных серверов
* опционально уменьшение изображений
* опциональное создание превью
* опциональное создание надписи на превью (размеры изображения / собственный текст)
* генерация ссылок на страницу просмотра, прямой ссылки на изображение, BB и html-кодов.
* генерация кодов с превью.
* при мультизагрузке генерируются общие BB и html-коды всех загруженных изображений

## Остальные возможности скрипта
* возможность установки в поддиректорию
* поддержка шаблонов
* страница просмотра загруженного изображения
* возможность ограничения предельно допустимого размера и разрешения загружаемого изображения
* изменение качества для jpg-изображений
* отображение лимита количества отдновременно загружаемых изображений, разрешенных форматов изображений и их размеров
* проверка загружаемых объектов по mime-type
* разбивка загрузки изображений по каталогам год-месяц/день
* вывод статистики количества загруженных на фотохостинг изображений за все время, за последние сутки и занимаемый объем

## Известные недоработки
https://github.com/vla7/akina/issues

## Планы
https://github.com/vla7/akina/issues

## УСТАНОВКА
1. Залить все файлы на хостинг
2. Установить владельцем файлов www-data (или ваш владелец процесса Apache) и права 755 для каталогов /img/, /thumbs/, /working/, /working/thumbs/ и файла /working/cachefile.dat
3. Пройтись по конфигу (файл config.php) и настроить все под себя. Например, выбрать шаблон из доступных в папке templates правкой переменной $config['template_name']
По умолчанию включен шаблон whatsyoursolution
4. Добавление статических страниц.
Файлы, в формате html можно размещать в папке с вашим шаблоном. Название должно быть в формате blablabla.static.tpl (".static.tpl" в конце - обязательно).
После размещения файла эта страница будет доступна по адресу http://yoursite.com/?p=blablabla (без ".static.tpl" в конце)

## ОБНОВЛЕНИЕ
### Переход с версии 1.0.8 и ниже, на версии 1.0.9 и выше
1. Залить на хостинг файл __checker.php
2. Запустить его http://yoursite.com/__checker.php
3. Внести изменения в файл config.php из дистрибутива 1.0.9 в поля подсвеченные красным цветом, (на локальном диске)
4. Если есть ваши собственные шаблоны или вы вносили в них изменения, сохранить их на локальный диск.
5. Залить все файлы на хостинг
6. Удалить файл __checker.php (он уже не нужен)
7. Пройтись по конфигу (файл config.php) - настроить остальное под себя.
При необходимости внести изменения в шаблоны.


## УДАЛЕНИЕ ИЗОБРАЖЕНИЙ
Для удаления давно непросматриваемых изображений, если у Вас VDS или выделенный сервер - подойдет решение

    find /путь/к/папке/с/изображениями -atime +60 -print
покажет изображения, которые не просматривались более 60 дней

    find /путь/к/папке/с/изображениями -atime +60 -print | wc -l
покажет количество изображений, которые не просматривались более 60 дней

удаление изображений, которые не просматривались более 60 дней:

    find /путь/к/папке/с/изображениями -atime +60 -print -delete
